f=netcdf('exp_T.nc');

addpath('../scripts/matlab_toolbox');
sparam=cell(0,5);
sparam(end+1,:)={'t',[12:1:24],[0:2:24],[-1:0.2:1],[-1:0.2:1]};
sparam(end+1,:)={'s',[36.3:0.05:36.8],[35.1:0.1:36.8],[-0.1:0.05:0.1],[-0.15:0.05:0.15]};
sparam(end+1,:)={'u',[-0.2:0.02:0.2],[-0.2:0.015:0.2],[-0.14:0.02:0.14],[-0.14:0.02:0.14]};
sparam(end+1,:)={'v',[-0.2:0.02:0.2],[-0.2:0.015:0.2],[-0.14:0.02:0.14],[-0.14:0.02:0.14]};
sparam(end+1,:)={'ssh',[-0.8:0.05:0.2],[-0.2:0.015:0.2],[-0.14:0.02:0.14],[-0.14:0.02:0.14]};

suff=cell(0,2);
suff(end+1,:)={'a_c_init','first guess (FG)'};
suff(end+1,:)={'b_forw0_48','forward du FG'};
suff(end+1,:)={'a_c_fin','param control final (AP)'};
suff(end+1,:)={'b_forwfin_48','forward du PA'};
suff(end+1,:)={'a_c_true','parametre vrai (TP)'};
suff(end+1,:)={'b_obs_48','forward du TP'};

suff2=cell(0,2);
suff2(end+1,:)={'n_c_init','first guess (FG)'};
suff2(end+1,:)={'b_forw0_48','forward du FG'};
suff2(end+1,:)={'n_c_fin','param control final (AP)'};
suff2(end+1,:)={'b_forwfin_48','forward du PA'};
suff2(end+1,:)={'n_c_true','parametre vrai (TP)'};
suff2(end+1,:)={'b_obs_48','forward du TP'};


delta=cell(0,2);
delta(end+1,:)={[1 5],'FG-true'};
delta(end+1,:)={[2 6],'obs-forwFG'};
delta(end+1,:)={[3 5],'true-rest'};
delta(end+1,:)={[4 6],'obs-forwPA'};

cmapdif=scol_dif_lin(64);


lati=f{'nav_lat'}(:,:);
longi=f{'nav_lon'}(:,:);
zlev=f{'nav_lev'}(:);

lat0=41;

for j=1:size(sparam,1)
  figure(j);clf
  figure(j+size(sparam,1));clf;
  figure(j+2*size(sparam,1));clf;
  figure(j+3*size(sparam,1));clf;
  paramy=cell(length(suff),1);
 
  for k=1:length(suff)
    
   if strcmp(sparam{j,1},'ssh')
     param=f{[sparam{j,1} suff2{k,1}]}(:,:,:);
     
      param=squeeze(param);
     paramy{k}=mat2yao(param);
     paramy{k}=mat2yao(param);
     paramy{k}(:,1:2)=fliplr(paramy{k}(:,1:2));
     paramy{k}=sortrows(paramy{k},[1 2]);
     figure(j);
    subplot(3,2,k)
    % contourf(longi(2:end-1,2:end-1),lati(2:end-1,2:end-1),param(2:end-1,2:end-1),sparam{j,2});
    % caxis([sparam{j,2}(1) sparam{j,2}(end)])
     %xlabel('longitude','Fontsize',9)
     %ylabel('latitude','Fontsize',9)
      plot_nemo_3D(paramy{k},longi,lati,zlev,1,sparam{j,2},1);

    
    title(suff2{k,2});
     if (k==1) 
      colorbar
     end
   
   else
     param=f{[sparam{j,1} suff{k,1}]}(:,:,:,:);
     param=squeeze(param);
     paramy{k}=mat2yao(param);
     paramy{k}(:,1:3)=fliplr(paramy{k}(:,1:3));
     paramy{k}=sortrows(paramy{k},[1 2 3]);
    figure(j);
    subplot(3,2,k)
    plot_nemo_3D(paramy{k},longi,lati,zlev,1,sparam{j,2},1);
    title(suff{k,2}) 
  
   
    if (k==1) 
      colorbar
    end
    figure(j+size(sparam,1));
    subplot(3,2,k)    
    plot_nemo_3D(paramy{k},longi,lati,zlev,lat0,sparam{j,3},2);
    title(suff{k,2})
    if (k==1) 
      colorbar
    end
   end %if ~ssh
    
  end %for k   
  
     %%Graphe des différences
    for k=1:size(delta,1)
      
      
      param=paramy{delta{k,1}(1)};
      param(:,end)=param(:,end)-paramy{delta{k,1}(2)}(:,end);
      
      figure(j+2*size(sparam,1))
      subplot(2,2,k)
      plot_nemo_3D(param,longi,lati,zlev,1,sparam{j,4},1);
      colormap(cmapdif);
      title(delta{k,2});
      if (k==2)
        colorbar
      end
      if ~strcmp(sparam{j,1},'ssh')
        figure(j+3*size(sparam,1))
        subplot(2,2,k)
        plot_nemo_3D(param,longi,lati,zlev,lat0,sparam{j,5},2);
        colormap(cmapdif);
        title(delta{k,2});
        if (k==2)
          colorbar
        end
      end % if ~ssh
      
      if strcmp(sparam{j,1},'ssh')
        n1=max(paramy{delta{k}(1)}(:,1));
        n2=max(paramy{delta{k}(1)}(:,2));
        iok=find(paramy{delta{k}(1)}(:,1)>1 & paramy{delta{k}(1)}(:,1)<n1 & paramy{delta{k}(1)}(:,2)>1 & ...
                 paramy{delta{k}(1)}(:,2)<n2);
      else
        n1=max(paramy{delta{k}(1)}(:,1));
        n2=max(paramy{delta{k}(1)}(:,2));
        n3=max(paramy{delta{k}(1)}(:,3));
        iok=find(paramy{delta{k}(1)}(:,1)>1 & paramy{delta{k}(1)}(:,1)<n1 & paramy{delta{k}(1)}(:,2)>1 & ...
                 paramy{delta{k}(1)}(:,2)<n2 & paramy{delta{k}(1)}(:,3)<n3);
      end
      
      
         %  fprintf(1,[int2str(j) sparam{j,1} ' ' delta{k,2} '\n']);
      [N(j,k),RPD(j,k),URPD(j,k),MAD(j,k),RMS(j,k),slope(j,k),intercept(j,k),r2(j,k) ]=make_stats(paramy{delta{k,1}(1)}(iok,end),paramy{delta{k,1}(2)} (iok,end));

    end %for k
  
  
  figure(j)
  suptitle(['parametre ' sparam{j,1} ' surface'])
  figure(j+size(sparam,1));
  suptitle(['parametre ' sparam{j,1} ' lat=40'])
  figure(j+2*size(sparam,1))
  suptitle(['erreur ' sparam{j,1} ' surface'])
  figure(j+3*size(sparam,1))
  suptitle(['erreur ' sparam{j,1} ' lat=40'])
end
close(f)

%sauvegarde du tableau

fid=fopen('tab.txt','w');
for j=1:size(sparam,1)

  fprintf(fid,'\n * Paramètre %s \n',sparam{j,1});
  fprintf(fid,'||Name  ||bias|| RMS || rel. err || r2    ||\n');
    for k=1:size(delta,1)
      

fprintf(fid,'||%s %s || %4.3e ||  %4.3e ||   %4.3f  || %4.3f ||\n',sparam{j,1},delta{k,2}, MAD(j,k),RMS(j,k), ...
        URPD(j,k),r2(j,k));

    end

    fprintf(fid,'\n');

end
fclose(fid);
