#==============================================================================
# 		fichier de D'INSTRUCTIONS de référence (SHORT version)
#Julien Brajard
#==============================================================================
#script faisant l'assimilation de référence version courte
#paramètres à régler : TA=10 (8 pdt effectifs)
#NX=32,NY=22,NZ=31
#paramères de contrôle : ta_c
#obs (3D a t=8 Yt=50) : sshb, tb, sb,ub,vb
#

##INITIALISATION
xistate_init 1 ../data_in/file_rest/GYRE_00000424_restart.nc
true_target_in_tab ta_c
xinitnc ../data_out/exp_T_short.nc

xwriteout 0 true ../data_out/exp_T_short.nc

print_time OFF
set_modeltime 0
FORWARD


##OBSERVATION
xwriteout 10 obs_8 ../data_out/exp_T_short.nc
savestate sshb  1   ij   10    A       1       ../data_out/sshb_obs_8.dat   
savestate tb  1   ijk   10    A       1       ../data_out/tb_obs_8.dat   
savestate sb  1   ijk   10    A       1       ../data_out/sb_obs_8.dat   
savestate ub  1   ijk   10    A       1       ../data_out/ub_obs_8.dat   
savestate vb  1   ijk   10    A       1       ../data_out/vb_obs_8.dat   

loadobs sshb  1   ij   10    A       1       ../data_out/sshb_obs_8.dat D   
loadobs tb  1   ijk   10    A       1       ../data_out/tb_obs_8.dat D   
loadobs sb  1   ijk   10    A       1       ../data_out/sb_obs_8.dat D   
loadobs ub  1   ijk   10    A       1       ../data_out/ub_obs_8.dat D   
loadobs vb  1   ijk   10    A       1       ../data_out/vb_obs_8.dat D   


#goto FINRUN

##INITIALISATION DE L'ASSIMILATION'
xistate_init 1 ../data_in/file_rest/GYRE_00000400_restart.nc
set_modeltime 0
print_time OFF
FORWARD

xwriteout 0 init ../data_out/exp_T_short.nc
xwriteout 10 forw0_8 ../data_out/exp_T_short.nc

##TEST DE LA FONCTION OBJECTIVE
goto FINTEST
testof 1.e+00 0.5e-01 2. 10 1
goto FINRUN
FINTEST
##DEBUT DE L'ASSIMILATION'

set_modeltime 0
!echo "RUN OPTIMIZATION WITH M1QN3 ......."
setm_impres  5
setm_io      6
setm_mode    1
set_nbiter   100
setm_nsim    100
setm_dxmin   1.0e-4
setm_epsg    1.0e-10
setm_ddf1    1
runm
##SAUVEGARDE
xwriteout 0 fin ../data_out/exp_T_short.nc
xwriteout 10 forwfin_8 ../data_out/exp_T_short.nc

xrst_save ../data_in/file_rest/GYRE_00000400_restart_CONTROL_T_short.nc



goto FINRUN


FINRUN

