
/***************************************************************************
                 module classe ta_traldf_lap.h  -  description
***************************************************************************/
// Mohamed Berrada
// locean-ipsl.upmc, Paris, April 2, 2009
//===========================================================================
//                          methode forward
forward (YREAL x1, YREAL x2, YREAL x3, YREAL x4, YREAL x5)
{ /*	1	from	ta_traadv_musc		1  i 	j    k    t
	2	from	ztuv_traldf_lap		1  i	j    k    t
	3	from	ztuv_traldf_lap		1  i-1	j    k    t
	4	from	ztuv_traldf_lap		2  i	j    k    t
	5	from	ztuv_traldf_lap		2  i	j-1  k    t*/
  /*     1.903724252353736e-11
	 7.053989989415242e-08*/

  if(Yt==TU)
    YS1=0.;
  else{
    if(Yi==0 || Yi==NX-1 || Yj==0 || Yj==NY-1 || Yk== NZ-1)
      YS1=x1;
    else{
#if defined key_zco
      double    zbtr = zbtr2(Yi,Yj);
#else
      double    zbtr = zbtr2(Yi,Yj) / fse3t(Yi,Yj,Yk);
#endif
      
      //       ! horizontal diffusive trends
      double  zta = zbtr*(x2-x3+x4-x5);
      //               ! add it to the general tracer trends
      YS1=x1+zta;
    }    
  }
  //
}

//===========================================================================
//                         methode  backward

backward (YREAL x1, YREAL x2, YREAL x3, YREAL x4, YREAL x5)
{
  YJ1I1=0.;     YJ1I2=0.;     YJ1I3=0.;     YJ1I4=0.;     YJ1I5=0.; 
  
  if(Yt!=TU){
    if(Yi==0 || Yi==NX-1 || Yj==0 || Yj==NY-1 || Yk== NZ-1){
      YJ1I1=1.;     YJ1I2=0.;     YJ1I3=0.;     YJ1I4=0.;     YJ1I5=0.; 
    }
    else{
#if defined key_zco
      double    zbtr = zbtr2(Yi,Yj);
#else
      double    zbtr = zbtr2(Yi,Yj) / fse3t(Yi,Yj,Yk);
#endif
      
      YJ1I1=  1.;
      YJ1I2=  zbtr;
      YJ1I3= -zbtr;
      YJ1I4=  zbtr;
      YJ1I5= -zbtr;  
    }    
  }
  //  
}

//===========================================================================
//*********************  FIN DU MODULE ta_traldf_lap   **********************

