
/***************************************************************************
                 module classe ua_dyn_ldf_lap.h  -  description
***************************************************************************/
// Mohamed Berrada
// locean-ipsl.upmc, Paris, Mars 11, 2009
//===========================================================================
//                          methode forward
forward (YREAL x1,YREAL x2,YREAL x3,YREAL x4,YREAL x5)
{/*	x1	from	ua_vor_ene		1  i    j    k    t
	x2	from	rotn			1  i    j-1  k    t-1
	x3	from	rotn			1  i    j    k    t-1
	x4	from	hdivn			1  i    j    k    t-1
	x5	from	hdivn		   	1  i+1  j    k    t-1*/

 /*if (Yi==30 && Yj==1 && Yk==0 && Yt<13)
  {
    printf("ua_dyn_ldf_lap:Yt=%i,x1=%f,x2=%f,x3=%f, x4=%f, x5=%f\n\n",Yt,x1,x2,x3,x4,x5);
      }  
 */

  if(Yt==TU)
    YS1=0.;
  else{
    double ze2u,ze1v,zua;
    if(Yk==NZ-1 || Yj==0 || Yj==NY-1 || Yi==0 || Yi==NX-1)
      YS1=0.;
    else{
#ifdef key_zco
      ze2u = x3*fsahmf(Yi,Yj,Yk);
      ze1v = x4*fsahmt(Yi,Yj,Yk);
      zua  = -(ze2u-x2*fsahmf(Yi,Yj-1,Yk))/e2u(Yi,Yj)
	+ (x5*fsahmt(Yi+1,Yj,Yk) - ze1v)/e1u(Yi,Yj);
      YS1  = x1+zua;
#else
      printf("erreur: .not.key_zco pas encore fait\n");
      exit(99);
#endif
    }
  }
  //  
}

//===========================================================================
//                         methode  backward

backward (YREAL x1,YREAL x2,YREAL x3,YREAL x4,YREAL x5)
{
  YJ1I1=0.;     YJ1I2=0.;   YJ1I3=0.;   YJ1I4=0.;     YJ1I5=0.; 
  if(Yt!=TU){  
    double ze2u,ze1v;
    if(Yk==NZ-1 || Yj==0 || Yj==NY-1 || Yi==0 || Yi==NX-1){
      YJ1I1=0.;     YJ1I2=0.;   YJ1I3=0.;   YJ1I4=0.;     YJ1I5=0.; 
    }
    else{
#ifdef key_zco
      ze2u = x3*fsahmf(Yi,Yj,Yk);
      double dze2u_x3 = fsahmf(Yi,Yj,Yk);
      ze1v = x4*fsahmt(Yi,Yj,Yk);
      double dze1v_x4 = fsahmt(Yi,Yj,Yk);
      double dzua_x2  = fsahmf(Yi,Yj-1,Yk)/e2u(Yi,Yj);
      double dzua_x3  = -dze2u_x3/e2u(Yi,Yj);
      double dzua_x4  = -dze1v_x4/e1u(Yi,Yj);
      double dzua_x5  = fsahmt(Yi+1,Yj,Yk)/e1u(Yi,Yj);
      YJ1I1= 1.;
      YJ1I2=dzua_x2;
      YJ1I3=dzua_x3;
      YJ1I4=dzua_x4;
      YJ1I5=dzua_x5;
#else
      printf("erreur: .not.key_zco pas encore fait\n");
      exit(99);
#endif
    }
  }
  //  
  
 }

  //===========================================================================
//********************* FIN DU MODULE ua_dyn_ldf_lap **********************

