
/***************************************************************************
                 module classe va_dyn_ldf_lap.h  -  description
***************************************************************************/
// Mohamed Berrada
// locean-ipsl.upmc, Paris, Mars 11, 2009
//===========================================================================
//                          methode forward
forward (YREAL x1,YREAL x2,YREAL x3,YREAL x4,YREAL x5)
{/*	x1	from	va_vor_ene		1  i    j    k    t
	x2	from	rotn			1  i-1  j    k    t-1
	x3	from	rotn			1  i    j    k    t-1
	x4	from	hdivn			1  i    j    k    t-1
	x5	from	hdivn		   	1  i    j+1  k    t-1*/

  if(Yt==TU)
    YS1=0.;
  else{
    double ze2u,ze1v,zva;
    if(Yk==NZ-1 || Yj==0 || Yj==NY-1 || Yi==0 || Yi==NX-1)
      YS1=0.;
    else{
#ifdef key_zco
      ze2u = x3*fsahmf(Yi,Yj,Yk);
      ze1v = x4*fsahmt(Yi,Yj,Yk);
      zva = +(ze2u-x2*fsahmf(Yi-1,Yj,Yk))/e1v(Yi,Yj)
	+ (x5*fsahmt(Yi,Yj+1,Yk) - ze1v)/e2v(Yi,Yj);
      YS1  = x1+zva;
#else
      printf("erreur: .not.key_zco pas encore fait\n");
      exit(99);
#endif
    }
  }
  //  
}

//===========================================================================
//                         methode  backward

backward (YREAL x1,YREAL x2,YREAL x3,YREAL x4,YREAL x5)
{
  
  YJ1I1=0.;     YJ1I2=0.;   YJ1I3=0.;   YJ1I4=0.;     YJ1I5=0.; 
  if(Yt!=TU){  
    double ze2u,ze1v;
    if(Yk==NZ-1 || Yj==0 || Yj==NY-1 || Yi==0 || Yi==NX-1){
      YJ1I1=0.;     YJ1I2=0.;   YJ1I3=0.;   YJ1I4=0.;     YJ1I5=0.; 
    }
    else{
#ifdef key_zco
      ze2u = x3*fsahmf(Yi,Yj,Yk);
      double dze2u_x3 = fsahmf(Yi,Yj,Yk);
      ze1v = x4*fsahmt(Yi,Yj,Yk);
      double dze1v_x4 = fsahmt(Yi,Yj,Yk);
      double dzva_x2 = -fsahmf(Yi-1,Yj,Yk)/e1v(Yi,Yj);
      double dzva_x3 = dze2u_x3/e1v(Yi,Yj);
      double dzva_x4 = -dze1v_x4/e2v(Yi,Yj);
      double dzva_x5 = fsahmt(Yi,Yj+1,Yk)/e2v(Yi,Yj);
      YJ1I1=1.;
      YJ1I2=dzva_x2;
      YJ1I3=dzva_x3;
      YJ1I4=dzva_x4;
      YJ1I5=dzva_x5; 

#else
      printf("erreur: .not.key_zco pas encore fait\n");
      exit(99);
#endif
    }
  }
  //  
 }

  //===========================================================================
//********************* FIN DU MODULE va_dyn_ldf_lap **********************

